import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletException;

import java.io.IOException;

import org.eclipse.jetty.server.Server;
import org.eclipse.jetty.server.Request;
import org.eclipse.jetty.server.handler.AbstractHandler;

public class HelloWorldJetty extends AbstractHandler {
    private static int PORT = 8080;

    public void handle(String target,
                       Request baseRequest,
                       HttpServletRequest request,
                       HttpServletResponse response) 
        throws IOException, ServletException {
        response.setContentType("text/html");
        response.setStatus(HttpServletResponse.SC_OK);
        baseRequest.setHandled(true);
        response.getWriter().println(
            "<html><head><title>Hello world</title></head><body>Hello world</body></html>");
    }
 
    public static void main(String[] args) throws Exception {
        Server server = new Server(PORT);
        server.setHandler(new HelloWorldJetty());
        System.out.println("Server is running on port " + PORT);
        server.start();
        server.join();
    }
}