#include <stdio.h>
#include <stdlib.h>
#include <event.h>
#include <evhttp.h>

#define PORT 8080
#define PAGE "<html><head><title>Hello world</title></head><body>Hello world</body></html>"

void generic_request_handler(struct evhttp_request *req, void *arg) {
    struct evbuffer *returnbuffer = evbuffer_new();
    evhttp_add_header(evhttp_request_get_output_headers(req), "Content-Type", "text/html");
    evhttp_add_header(evhttp_request_get_output_headers(req), "Connection", "keep-alive");
    evbuffer_add_printf(returnbuffer, PAGE);
    evhttp_send_reply_start(req, HTTP_OK, "OK");
    evhttp_send_reply_chunk(req, returnbuffer);
    evhttp_send_reply_end(req);
    evbuffer_free(returnbuffer);
    return;
}

int main(int argc, char **argv) {
    event_init();
    evhttp_set_gencb(evhttp_start( "0.0.0.0", PORT), generic_request_handler, NULL);
    fprintf(stderr, "Server started on port %d\n", PORT);
    event_dispatch();
    return(0);
}