#include <microhttpd.h>
#include <string.h>
#include <stdio.h>

#define PORT 8080
#define PAGE "<html><head><title>Hello world</title></head><body>Hello world</body></html>"

static struct MHD_Response *response;

static int ahc_echo(void *cls, struct MHD_Connection *connection, const char *url, const char *method,
                    const char *version, const char *upload_data, size_t *upload_data_size, void **ptr) {
    return MHD_queue_response(connection, MHD_HTTP_OK, response);
}

int main(int argc, char *const *argv) {
    struct MHD_Daemon *d;
    response = MHD_create_response_from_buffer(strlen(PAGE), (void *) PAGE, MHD_RESPMEM_PERSISTENT);
    (void) MHD_add_response_header(response, MHD_HTTP_HEADER_CONTENT_TYPE, "text/html");
    d = MHD_start_daemon(
            MHD_USE_EPOLL_INTERNALLY_LINUX_ONLY | MHD_USE_EPOLL_TURBO | MHD_USE_TCP_FASTOPEN,
            PORT, NULL, NULL, &ahc_echo, NULL,
            MHD_OPTION_CONNECTION_LIMIT, (unsigned int) 10000,
            MHD_OPTION_END);
    if (d == NULL)
        return 1;
    printf("Server is running on port %d", PORT);
    getchar();
    MHD_stop_daemon(d);
    MHD_destroy_response(response);
    return 0;
}